'Ce script permet d optimiser les images (et de passer celles en erreurs)
Set objFS = CreateObject("Scripting.FileSystemObject")

sSource=objFS.GetAbsolutePathName(".") & "\src"
sTmp=objFS.GetAbsolutePathName(".") & "\tmp"
sTmpDest=objFS.GetAbsolutePathName(".") & "\tmpdest"
sDest=objFS.GetAbsolutePathName(".") & "\dest"

'Reset
Set fs = objFS.getFolder(sDest)
For Each file In fs.Files
    objFS.deleteFile (file)
Next
Set fs = objFS.getFolder(sDest)
For Each file In fs.subfolders
    objFS.deleteFolder (file)
Next

If objFS.FolderExists(sTmp) Then
    objFS.deleteFolder (sTmp)
End If
Call BuildFullPath(sTmp, objFS)

If objFS.FolderExists(sTmpDest) Then
    objFS.deleteFolder (sTmpDest)
End If
Call BuildFullPath(sTmpDest, objFS)

Call recFile(sSource, sDest, sSource, sTmp, sTmpDest)

f1 = Round(getSize(sSource, 0) / 1000, 0)
f2 = Round(getSize(sDest, 0) / 1000, 0)

MsgBox "Voici les tailles:" & vbCrLf & "Avant: " & CStr(f1) & " Mb" & vbCrLf & "Apres: " & CStr(f2) & " Mb", 64, "Optimisation terminee"



'Parcourt un repertoire . Pour chaque fichier de la source, le copie dans tmp, lance gulp, et recopie la sortie dans dest
Function recFile(sFolder, sDest, sSource, sTmp, sTmpDest)
    Set objFS = CreateObject("Scripting.FileSystemObject")
    Set folder = objFS.getFolder(sFolder)
    
    'Creation des repertoires destination
    sTmpFolder = sFolder
    sTmpFolder = Replace(sTmpFolder, sSource, sDest)
    Call BuildFullPath(sTmpFolder, objFS)
      
    For Each file In folder.Files
        sFile = LCase(file)
        If (Right(sFile, 3) = "jpg" Or Right(sFile, 4) = "jpeg" Or Right(sFile, 3) = "png" Or Right(sFile, 3) = "svg") Then
            sTmpFolder = sFolder
            sTmpFolder = Replace(sTmpFolder, sSource, sTmp)
			
            Call BuildFullPath(sTmpFolder, objFS)
            Call objFS.CopyFile(sFile, sTmpFolder & "\" & file.Name)
            Set oShell = CreateObject("WScript.Shell")
            sFileLog = "output.log"
            bExec = oShell.Run("gulp --task default >" & sFileLog, 7, 1)
            sTmpFolder = Left(file.Path, Len(file.Path) - Len(file.Name))
            sFileDest = sTmpFolder & file.Name
            sFileDestFinal = sTmpFolder & file.Name
            sFileDest = Replace(sFileDest, sSource, sTmpDest)
            sFileDestFinal = Replace(sFileDestFinal, sSource, sDest)
            sTmpFolder = Replace(sTmpFolder, sSource, sDest)
            
            Call BuildFullPath(sTmpFolder, objFS)
            If objFS.fileExists(sFileDest) Then
                Call objFS.CopyFile(sFileDest, sTmpFolder & "\" & file.Name)
            Else
                Call objFS.CopyFile(file.Path, sTmpFolder & "\" & file.Name)
            End If
            
            'Reset
            Set fs = objFS.getFolder(sTmp)
            For Each xfile In fs.Files
                objFS.deleteFile (xfile)
            Next
            Set fs = objFS.getFolder(sTmp)
            For Each xfile In fs.subfolders
                objFS.deleteFolder (xfile)
            Next
            
            Set fs = objFS.getFolder(sTmpDest)
            For Each xfile In fs.Files
                objFS.deleteFile (xfile)
            Next
            Set fs = objFS.getFolder(sTmpDest)
            For Each xfile In fs.subfolders
                objFS.deleteFolder (xfile)
            Next

        Else
            sTmpFolder = Left(file.Path, Len(file.Path) - Len(file.Name))
            sTmpFolder = Replace(sTmpFolder, sSource, sDest)
            Call BuildFullPath(sTmpFolder, objFS)
            Call objFS.CopyFile(sFile, sTmpFolder & "\" & file.Name)
        End If
    Next
    For Each subFolder In folder.subfolders
        Call recFile(CStr(subFolder), sDest, sSource, sTmp, sTmpDest)
    Next
End Function

Sub BuildFullPath(FullPath, fso)
	If Not fso.FolderExists(FullPath) Then
        Call BuildFullPath(fso.GetParentFolderName(FullPath), fso)
        fso.CreateFolder FullPath
    End If
End Sub

'Calcule la taille des images dans les dossiers
Function getSize(sFolder, iTotal)
    Set objFS = CreateObject("Scripting.FileSystemObject")
    Set folder = objFS.getFolder(sFolder)
    For Each file In folder.Files
        sFile = LCase(file)
        If (Right(sFile, 3) = "jpg" Or Right(sFile, 4) = "jpeg" Or Right(sFile, 3) = "png" Or Right(sFile, 3) = "svg") Then
            iTotal = iTotal + file.Size / 1000
        End If
    Next
    For Each subFolder In folder.subfolders
        iTotal = getSize(CStr(subFolder), iTotal)
    Next
    getSize = iTotal
End Function

