const gulp = require('gulp');
const imagemin = require('gulp-imagemin');
const imageminGuetzli = require('imagemin-guetzli');
var plumber = require("gulp-plumber");

//Optimisation des images
var allimages = [
        'tmp/**/*.{jpg,JPG,jpeg,JPEG,PNG,png,SVG,svg}'
    ];
	
gulp.task('default', () =>
    gulp.src(allimages)
	.pipe(imagemin([
        imageminGuetzli({
            quality: 85,
			nomemlimit:true
        })
    ]))
	.on('error', swallowError)
	.pipe(imagemin([
		imagemin.gifsicle({interlaced: true}),
		imagemin.jpegtran({progressive: true}),
		imagemin.optipng({optimizationLevel: 5}),
		imagemin.svgo({
			plugins: [
				{removeViewBox: true},
				{cleanupIDs: false}
			]
		})
	]))
	.on('error', swallowError)
    .pipe(gulp.dest('tmpdest'))
);

//Creation des css LESS
gulp.task('css', function () {
  return gulp.src(source + '/src/css/styles.less')
    .pipe(plugins.less())
    .pipe(gulp.dest('dest/css'));
});

function swallowError (error) {
  // If you want details of the error in the console
  console.log(error.toString()) 
}